Index: Makefile
===================================================================
--- Makefile	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ Makefile	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -30,8 +30,5 @@
 #
 
-CSCOPE = cscope
-STANSE = stanse
-
-.PHONY: all config config_default distclean clean cscope stanse
+.PHONY: all config config_default distclean clean cscope
 
 all: Makefile.config config.h config.defs
@@ -39,12 +36,4 @@
 	$(MAKE) -C uspace
 	$(MAKE) -C boot
-
-stanse: Makefile.config config.h config.defs
-	$(MAKE) -C kernel clean
-	$(MAKE) -C kernel EXTRA_TOOL=stanse
-	$(STANSE) --checker ReachabilityChecker --jobfile kernel/kernel.job
-
-cscope:
-	find kernel boot uspace -regex '^.*\.[chsS]$$' | xargs $(CSCOPE) -b -k -u -f$(CSCOPE).out
 
 Makefile.config: config_default
@@ -61,8 +50,13 @@
 
 distclean: clean
-	rm -f $(CSCOPE).out Makefile.config config.h config.defs tools/*.pyc
+	rm -f Makefile.config config.h config.defs tools/*.pyc
 
 clean:
-	$(MAKE) -C kernel clean
-	$(MAKE) -C uspace clean
-	$(MAKE) -C boot clean
+	-$(MAKE) -C kernel clean
+	-$(MAKE) -C uspace clean
+	-$(MAKE) -C boot clean
+
+cscope:
+	find kernel boot uspace -regex '^.*\.[chsS]$$' -print > srclist
+	rm -f cscope.out
+	cscope -bi srclist
Index: boot/arch/amd64/Makefile.inc
===================================================================
--- boot/arch/amd64/Makefile.inc	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ boot/arch/amd64/Makefile.inc	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -27,31 +27,53 @@
 #
 
-include Makefile.common
+TMP = distroot
 
-RD_SRVS += \
+INIT_TASKS = \
+	$(USPACEDIR)/srv/ns/ns \
+	$(USPACEDIR)/srv/loader/loader \
+	$(USPACEDIR)/app/init/init \
+	$(USPACEDIR)/srv/devmap/devmap \
+	$(USPACEDIR)/srv/bd/rd/rd \
+	$(USPACEDIR)/srv/vfs/vfs
+ifeq ($(RDFMT),tmpfs)
+	INIT_TASKS += $(USPACEDIR)/srv/fs/tmpfs/tmpfs
+endif
+ifeq ($(RDFMT),fat)
+	INIT_TASKS += $(USPACEDIR)/srv/fs/fat/fat
+endif
+
+RD_SRVS = \
 	$(USPACEDIR)/srv/pci/pci \
-	$(USPACEDIR)/srv/bd/ata_bd/ata_bd
+	$(USPACEDIR)/srv/fb/fb \
+	$(USPACEDIR)/srv/kbd/kbd \
+	$(USPACEDIR)/srv/console/console \
+	$(USPACEDIR)/srv/fs/devfs/devfs \
+	$(USPACEDIR)/srv/fs/tmpfs/tmpfs \
+	$(USPACEDIR)/srv/fs/fat/fat \
+	$(USPACEDIR)/srv/bd/ata_bd/ata_bd \
+	$(USPACEDIR)/srv/bd/file_bd/file_bd \
+	$(USPACEDIR)/srv/part/mbr_part/mbr_part
 
-MODULES := $(notdir $(COMPONENTS))
+RD_APPS = \
+	$(USPACEDIR)/app/edit/edit \
+	$(USPACEDIR)/app/getvc/getvc \
+	$(USPACEDIR)/app/redir/redir \
+	$(USPACEDIR)/app/tetris/tetris \
+	$(USPACEDIR)/app/tester/tester \
+	$(USPACEDIR)/app/trace/trace \
+	$(USPACEDIR)/app/klog/klog \
+	$(USPACEDIR)/app/bdsh/bdsh
 
 build: $(BASE)/image.iso
 
-$(BASE)/image.iso: arch/$(BARCH)/grub/stage2_eltorito $(KERNELDIR)/kernel.bin $(INIT_TASKS) $(RD_SRVS) $(RD_APPS)
+$(BASE)/image.iso: arch/$(BARCH)/grub/stage2_eltorito arch/$(BARCH)/grub/menu.lst $(KERNELDIR)/kernel.bin $(INIT_TASKS) $(RD_SRVS) $(RD_APPS)
 	mkdir -p $(TMP)/boot/grub
 	cp arch/$(BARCH)/grub/stage2_eltorito $(TMP)/boot/grub/
-	
-	echo "default 0" > $(TMP)/boot/grub/menu.lst
-	echo "timeout 10" >> $(TMP)/boot/grub/menu.lst
-	echo "" >> $(TMP)/boot/grub/menu.lst
-	echo "title=HelenOS" >> $(TMP)/boot/grub/menu.lst
-	echo "	root (cd)" >> $(TMP)/boot/grub/menu.lst
-	for module in $(MODULES) $(INITRD).img ; do \
-		if [ $$module = kernel.bin ] ; then \
-			echo "	kernel /boot/$$module" >> $(TMP)/boot/grub/menu.lst ; \
-		else \
-			echo "	module /boot/$$module" >> $(TMP)/boot/grub/menu.lst ; \
-		fi \
-	done
-	
+ifneq ($(RDFMT),tmpfs)
+	cat arch/$(BARCH)/grub/menu.lst | grep -v "tmpfs" > $(TMP)/boot/grub/menu.lst
+endif
+ifneq ($(RDFMT),fat)
+	cat arch/$(BARCH)/grub/menu.lst | grep -v "fat" > $(TMP)/boot/grub/menu.lst
+endif
 	cp $(KERNELDIR)/kernel.bin $(TMP)/boot/
 	for task in $(INIT_TASKS) ; do \
@@ -64,13 +86,12 @@
 		cp $$file $(USPACEDIR)/dist/app/ ; \
 	done
-	
 ifeq ($(RDFMT),tmpfs)
-	$(BASE)/tools/mktmpfs.py $(USPACEDIR)/dist/ $(TMP)/boot/$(INITRD).fs
+	$(BASE)/tools/mktmpfs.py $(USPACEDIR)/dist/ $(TMP)/boot/initrd.fs
 endif
 ifeq ($(RDFMT),fat)
-	$(BASE)/tools/mkfat.py $(USPACEDIR)/dist/ $(TMP)/boot/$(INITRD).fs
+	$(BASE)/tools/mkfat.py $(USPACEDIR)/dist/ $(TMP)/boot/initrd.fs
 endif
-	$(BASE)/tools/mkhord.py 4096 $(TMP)/boot/$(INITRD).fs $(TMP)/boot/$(INITRD).img
-	rm $(TMP)/boot/$(INITRD).fs
+	$(BASE)/tools/mkhord.py 4096 $(TMP)/boot/initrd.fs $(TMP)/boot/initrd.img
+	rm $(TMP)/boot/initrd.fs
 	mkisofs -J -r -b boot/grub/stage2_eltorito -no-emul-boot -boot-load-size 4 -boot-info-table -o $@ $(TMP)/
 
Index: boot/arch/amd64/grub/menu.lst
===================================================================
--- boot/arch/amd64/grub/menu.lst	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
+++ boot/arch/amd64/grub/menu.lst	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -0,0 +1,15 @@
+default 0
+timeout 10
+
+title=HelenOS
+	root (cd)
+	kernel /boot/kernel.bin
+	module /boot/ns
+	module /boot/init
+	module /boot/devmap
+	module /boot/rd
+	module /boot/vfs
+	module /boot/tmpfs
+	module /boot/fat
+	module /boot/loader
+	module /boot/initrd.img
Index: boot/arch/arm32/loader/Makefile.build
===================================================================
--- boot/arch/arm32/loader/Makefile.build	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ boot/arch/arm32/loader/Makefile.build	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -51,4 +51,19 @@
 	../../../genarch/division.c
 
+COMPONENTS = \
+	$(KERNELDIR)/kernel.bin \
+	$(USPACEDIR)/srv/ns/ns \
+	$(USPACEDIR)/srv/loader/loader \
+	$(USPACEDIR)/app/init/init \
+	$(USPACEDIR)/srv/devmap/devmap \
+	$(USPACEDIR)/srv/bd/rd/rd \
+	$(USPACEDIR)/srv/vfs/vfs
+ifeq ($(RDFMT),tmpfs)
+	COMPONENTS += $(USPACEDIR)/srv/fs/tmpfs/tmpfs
+endif
+ifeq ($(RDFMT),fat)
+	COMPONENTS += $(USPACEDIR)/srv/fs/fat/fat
+endif
+
 OBJECTS := $(addsuffix .o,$(basename $(SOURCES)))
 COMPONENT_OBJECTS := $(addsuffix .co,$(basename $(notdir $(COMPONENTS)))) $(INITRD).co
Index: boot/arch/arm32/loader/Makefile.common
===================================================================
--- boot/arch/arm32/loader/Makefile.common	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ boot/arch/arm32/loader/Makefile.common	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -31,6 +31,4 @@
 #
 
-include ../../../Makefile.common
-
 DEPEND = Makefile.depend
 DEPEND_PREV = $(DEPEND).prev
@@ -39,7 +37,27 @@
 LINK = _link.ld
 COMPS = _components
+INITRD = initrd
 
 KERNELDIR = ../../../../kernel
 USPACEDIR = ../../../../uspace
 
-RD_SRVS += $(USPACEDIR)/srv/bd/gxe_bd/gxe_bd
+RD_SRVS = \
+	$(USPACEDIR)/srv/fb/fb \
+	$(USPACEDIR)/srv/kbd/kbd \
+	$(USPACEDIR)/srv/console/console \
+	$(USPACEDIR)/srv/fs/devfs/devfs \
+	$(USPACEDIR)/srv/fs/tmpfs/tmpfs \
+	$(USPACEDIR)/srv/fs/fat/fat \
+	$(USPACEDIR)/srv/bd/file_bd/file_bd \
+	$(USPACEDIR)/srv/part/mbr_part/mbr_part \
+	$(USPACEDIR)/srv/bd/gxe_bd/gxe_bd
+
+RD_APPS = \
+	$(USPACEDIR)/app/edit/edit \
+	$(USPACEDIR)/app/getvc/getvc \
+	$(USPACEDIR)/app/redir/redir \
+	$(USPACEDIR)/app/tetris/tetris \
+	$(USPACEDIR)/app/tester/tester \
+	$(USPACEDIR)/app/trace/trace \
+	$(USPACEDIR)/app/klog/klog \
+	$(USPACEDIR)/app/bdsh/bdsh
Index: boot/arch/ia64/loader/Makefile.build
===================================================================
--- boot/arch/ia64/loader/Makefile.build	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ boot/arch/ia64/loader/Makefile.build	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -49,4 +49,19 @@
 	boot.S
 
+COMPONENTS = \
+	$(KERNELDIR)/kernel.bin \
+	$(USPACEDIR)/srv/ns/ns \
+	$(USPACEDIR)/srv/loader/loader \
+	$(USPACEDIR)/app/init/init \
+	$(USPACEDIR)/srv/devmap/devmap \
+	$(USPACEDIR)/srv/bd/rd/rd \
+	$(USPACEDIR)/srv/vfs/vfs
+ifeq ($(RDFMT),tmpfs)
+	COMPONENTS += $(USPACEDIR)/srv/fs/tmpfs/tmpfs
+endif
+ifeq ($(RDFMT),fat)
+	COMPONENTS += $(USPACEDIR)/srv/fs/fat/fat
+endif
+
 OBJECTS := $(addsuffix .o,$(basename $(SOURCES)))
 COMPONENT_OBJECTS := $(addsuffix .co,$(basename $(notdir $(COMPONENTS)))) $(INITRD).co
Index: boot/arch/ia64/loader/Makefile.common
===================================================================
--- boot/arch/ia64/loader/Makefile.common	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ boot/arch/ia64/loader/Makefile.common	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -31,6 +31,4 @@
 #
 
-include ../../../Makefile.common
-
 DEPEND = Makefile.depend
 DEPEND_PREV = $(DEPEND).prev
@@ -40,5 +38,26 @@
 LINK = _link.ld
 COMPS = _components
+INITRD = initrd
 
 KERNELDIR = ../../../../kernel
 USPACEDIR = ../../../../uspace
+
+RD_SRVS = \
+	$(USPACEDIR)/srv/fb/fb \
+	$(USPACEDIR)/srv/kbd/kbd \
+	$(USPACEDIR)/srv/console/console \
+	$(USPACEDIR)/srv/fs/devfs/devfs \
+	$(USPACEDIR)/srv/fs/tmpfs/tmpfs \
+	$(USPACEDIR)/srv/fs/fat/fat \
+	$(USPACEDIR)/srv/bd/file_bd/file_bd \
+	$(USPACEDIR)/srv/part/mbr_part/mbr_part
+
+RD_APPS = \
+	$(USPACEDIR)/app/edit/edit \
+	$(USPACEDIR)/app/getvc/getvc \
+	$(USPACEDIR)/app/redir/redir \
+	$(USPACEDIR)/app/tetris/tetris \
+	$(USPACEDIR)/app/tester/tester \
+	$(USPACEDIR)/app/trace/trace \
+	$(USPACEDIR)/app/klog/klog \
+	$(USPACEDIR)/app/bdsh/bdsh
Index: boot/arch/mips32/loader/Makefile.build
===================================================================
--- boot/arch/mips32/loader/Makefile.build	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ boot/arch/mips32/loader/Makefile.build	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -49,4 +49,19 @@
 	boot.S
 
+COMPONENTS = \
+	$(KERNELDIR)/kernel.bin \
+	$(USPACEDIR)/srv/ns/ns \
+	$(USPACEDIR)/srv/loader/loader \
+	$(USPACEDIR)/app/init/init \
+	$(USPACEDIR)/srv/devmap/devmap \
+	$(USPACEDIR)/srv/bd/rd/rd \
+	$(USPACEDIR)/srv/vfs/vfs
+ifeq ($(RDFMT),tmpfs)
+	COMPONENTS += $(USPACEDIR)/srv/fs/tmpfs/tmpfs
+endif
+ifeq ($(RDFMT),fat)
+	COMPONENTS += $(USPACEDIR)/srv/fs/fat/fat
+endif
+
 OBJECTS := $(addsuffix .o,$(basename $(SOURCES)))
 COMPONENT_OBJECTS := $(addsuffix .co,$(basename $(notdir $(COMPONENTS)))) $(INITRD).co
Index: boot/arch/mips32/loader/Makefile.common
===================================================================
--- boot/arch/mips32/loader/Makefile.common	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ boot/arch/mips32/loader/Makefile.common	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -31,6 +31,4 @@
 #
 
-include ../../../Makefile.common
-
 DEPEND = Makefile.depend
 DEPEND_PREV = $(DEPEND).prev
@@ -40,7 +38,27 @@
 LINK = _link.ld
 COMPS = _components
+INITRD = initrd
 
 KERNELDIR = ../../../../kernel
 USPACEDIR = ../../../../uspace
 
-RD_SRVS += $(USPACEDIR)/srv/bd/gxe_bd/gxe_bd
+RD_SRVS = \
+	$(USPACEDIR)/srv/fb/fb \
+	$(USPACEDIR)/srv/kbd/kbd \
+	$(USPACEDIR)/srv/console/console \
+	$(USPACEDIR)/srv/fs/devfs/devfs \
+	$(USPACEDIR)/srv/fs/tmpfs/tmpfs \
+	$(USPACEDIR)/srv/fs/fat/fat \
+	$(USPACEDIR)/srv/bd/file_bd/file_bd \
+	$(USPACEDIR)/srv/part/mbr_part/mbr_part \
+	$(USPACEDIR)/srv/bd/gxe_bd/gxe_bd
+
+RD_APPS = \
+	$(USPACEDIR)/app/edit/edit \
+	$(USPACEDIR)/app/getvc/getvc \
+	$(USPACEDIR)/app/redir/redir \
+	$(USPACEDIR)/app/tetris/tetris \
+	$(USPACEDIR)/app/tester/tester \
+	$(USPACEDIR)/app/trace/trace \
+	$(USPACEDIR)/app/klog/klog \
+	$(USPACEDIR)/app/bdsh/bdsh
Index: boot/arch/ppc32/Makefile.inc
===================================================================
--- boot/arch/ppc32/Makefile.inc	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ boot/arch/ppc32/Makefile.inc	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -27,5 +27,5 @@
 #
 
-include Makefile.common
+TMP = distroot
 
 build: $(BASE)/image.iso
Index: boot/arch/ppc32/loader/Makefile.build
===================================================================
--- boot/arch/ppc32/loader/Makefile.build	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ boot/arch/ppc32/loader/Makefile.build	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -52,4 +52,19 @@
 	boot.S
 
+COMPONENTS = \
+	$(KERNELDIR)/kernel.bin \
+	$(USPACEDIR)/srv/ns/ns \
+	$(USPACEDIR)/app/init/init \
+	$(USPACEDIR)/srv/loader/loader \
+	$(USPACEDIR)/srv/devmap/devmap \
+	$(USPACEDIR)/srv/bd/rd/rd \
+	$(USPACEDIR)/srv/vfs/vfs
+ifeq ($(RDFMT),tmpfs)
+	COMPONENTS += $(USPACEDIR)/srv/fs/tmpfs/tmpfs
+endif
+ifeq ($(RDFMT),fat)
+	COMPONENTS += $(USPACEDIR)/srv/fs/fat/fat
+endif
+
 OBJECTS := $(addsuffix .o,$(basename $(SOURCES)))
 COMPONENT_OBJECTS := $(addsuffix .co,$(basename $(notdir $(COMPONENTS)))) $(INITRD).co
Index: boot/arch/ppc32/loader/Makefile.common
===================================================================
--- boot/arch/ppc32/loader/Makefile.common	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ boot/arch/ppc32/loader/Makefile.common	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -31,6 +31,4 @@
 #
 
-include ../../../Makefile.common
-
 DEPEND = Makefile.depend
 DEPEND_PREV = $(DEPEND).prev
@@ -39,5 +37,26 @@
 LINK = _link.ld
 COMPS = _components
+INITRD = initrd
 
 KERNELDIR = ../../../../kernel
 USPACEDIR = ../../../../uspace
+
+RD_SRVS = \
+	$(USPACEDIR)/srv/fb/fb \
+	$(USPACEDIR)/srv/kbd/kbd \
+	$(USPACEDIR)/srv/console/console \
+	$(USPACEDIR)/srv/fs/devfs/devfs \
+	$(USPACEDIR)/srv/fs/tmpfs/tmpfs \
+	$(USPACEDIR)/srv/fs/fat/fat \
+	$(USPACEDIR)/srv/bd/file_bd/file_bd \
+	$(USPACEDIR)/srv/part/mbr_part/mbr_part
+
+RD_APPS = \
+	$(USPACEDIR)/app/edit/edit \
+	$(USPACEDIR)/app/getvc/getvc \
+	$(USPACEDIR)/app/redir/redir \
+	$(USPACEDIR)/app/tetris/tetris \
+	$(USPACEDIR)/app/tester/tester \
+	$(USPACEDIR)/app/trace/trace \
+	$(USPACEDIR)/app/klog/klog \
+	$(USPACEDIR)/app/bdsh/bdsh
Index: boot/arch/sparc64/Makefile.inc
===================================================================
--- boot/arch/sparc64/Makefile.inc	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ boot/arch/sparc64/Makefile.inc	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -27,5 +27,5 @@
 #
 
-include Makefile.common
+TMP = distroot
 
 ifeq ($(CONFIG_AOUT_ISOFS_B),y)
Index: boot/arch/sparc64/loader/Makefile.build
===================================================================
--- boot/arch/sparc64/loader/Makefile.build	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ boot/arch/sparc64/loader/Makefile.build	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -52,4 +52,19 @@
 	boot.S
 
+COMPONENTS = \
+	$(KERNELDIR)/kernel.bin \
+	$(USPACEDIR)/srv/ns/ns \
+	$(USPACEDIR)/app/init/init \
+	$(USPACEDIR)/srv/loader/loader \
+	$(USPACEDIR)/srv/devmap/devmap \
+	$(USPACEDIR)/srv/bd/rd/rd \
+	$(USPACEDIR)/srv/vfs/vfs
+ifeq ($(RDFMT),tmpfs)
+	COMPONENTS += $(USPACEDIR)/srv/fs/tmpfs/tmpfs
+endif
+ifeq ($(RDFMT),fat)
+	COMPONENTS += $(USPACEDIR)/srv/fs/fat/fat
+endif
+
 OBJECTS := $(addsuffix .o,$(basename $(SOURCES)))
 
Index: boot/arch/sparc64/loader/Makefile.common
===================================================================
--- boot/arch/sparc64/loader/Makefile.common	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ boot/arch/sparc64/loader/Makefile.common	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -31,6 +31,4 @@
 #
 
-include ../../../Makefile.common
-
 DEPEND = Makefile.depend
 DEPEND_PREV = $(DEPEND).prev
@@ -39,7 +37,26 @@
 LINK = _link.ld
 COMPS = _components
+INITRD = initrd
 
 KERNELDIR = ../../../../kernel
 USPACEDIR = ../../../../uspace
+
+RD_SRVS = \
+	$(USPACEDIR)/srv/fb/fb \
+	$(USPACEDIR)/srv/kbd/kbd \
+	$(USPACEDIR)/srv/console/console \
+	$(USPACEDIR)/srv/fs/devfs/devfs \
+	$(USPACEDIR)/srv/fs/tmpfs/tmpfs \
+	$(USPACEDIR)/srv/bd/file_bd/file_bd \
+	$(USPACEDIR)/srv/part/mbr_part/mbr_part
+
+RD_APPS = \
+	$(USPACEDIR)/app/edit/edit \
+	$(USPACEDIR)/app/getvc/getvc \
+	$(USPACEDIR)/app/redir/redir \
+	$(USPACEDIR)/app/tetris/tetris \
+	$(USPACEDIR)/app/trace/trace \
+	$(USPACEDIR)/app/klog/klog \
+	$(USPACEDIR)/app/bdsh/bdsh
 
 RD_SRVS_GENERIC = \
Index: contrib/bazaar/mbprotect/__init__.py
===================================================================
--- contrib/bazaar/mbprotect/__init__.py	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ contrib/bazaar/mbprotect/__init__.py	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -52,17 +52,10 @@
 	return
 
-    # First permitted case is appending changesets to main branch.Look for
-    # old tip in new main branch.
+    # Look for old tip in new main branch.
     for revision_id in repo.iter_reverse_revision_history(params.new_revid):
 	if revision_id == params.old_revid:
 	    return	# Found old tip
 
-    # Another permitted case is backing out changesets. Look for new tip
-    # in old branch.
-    for revision_id in repo.iter_reverse_revision_history(params.old_revid):
-	if revision_id == params.new_revid:
-	    return	# Found new tip
-
-    # Trying to do something else. Reject the change.
+    # Old tip was not found. Reject the change.
     raise TipChangeRejected('Bad tip. Read http://trac.helenos.org/trac.fcgi/' +
 	'wiki/BazaarWorkflow')
Index: kernel/Makefile
===================================================================
--- kernel/Makefile	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/Makefile	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -33,8 +33,7 @@
 all: ../version ../Makefile.config ../config.h ../config.defs
 	-[ -f $(DEPEND) ] && mv -f $(DEPEND) $(DEPEND_PREV)
-	$(MAKE) -f Makefile.build EXTRA_TOOL=$(EXTRA_TOOL)
+	$(MAKE) -f Makefile.build
 
 clean:
-	rm -f $(DEPEND) $(DEPEND_PREV) $(RAW) $(BIN) $(MAP) $(JOB) $(MAP_PREV) $(DISASM) $(DUMP) $(REAL_MAP).* $(ARCH_INCLUDE) $(GENARCH_INCLUDE) arch/*/_link.ld
+	rm -f $(DEPEND) $(DEPEND_PREV) $(RAW) $(BIN) $(MAP) $(MAP_PREV) $(DISASM) $(DUMP) $(REAL_MAP).* $(ARCH_INCLUDE) $(GENARCH_INCLUDE) arch/*/_link.ld
 	find generic/src/ arch/*/src/ genarch/src/ test/ -name '*.o' -follow -exec rm \{\} \;
-	find generic/src/ arch/*/src/ genarch/src/ test/ -name '*.o.preproc' -follow -exec rm \{\} \;
Index: kernel/Makefile.build
===================================================================
--- kernel/Makefile.build	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/Makefile.build	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -91,5 +91,5 @@
 ## Cross-platform assembly to start a symtab.data section
 #
-SYMTAB_SECTION = ".section symtab.data, \"a\", $(ATSIGN)progbits;"
+SYMTAB_SECTION=".section symtab.data, \"a\", $(ATSIGN)progbits;"
 
 ## Simple detection for the type of the host system
@@ -110,5 +110,5 @@
 ifeq ($(COMPILER),gcc_native)
 	CC = gcc
-	GCC = gcc
+	GCC = $(CC)
 	AS = $(BINUTILS_PREFIX)as
 	LD = $(BINUTILS_PREFIX)ld
@@ -168,5 +168,4 @@
 	DEPEND_DEFS = $(DEFS) $(CONFIG_DEFS)
 endif
-
 
 ## Generic kernel sources
@@ -385,7 +384,4 @@
 test/fpu/%.o: test/fpu/%.c $(DEPEND)
 	$(CC) $(DEFS) $(CFLAGS) $(EXTRA_FLAGS) -c $< -o $@
-ifeq ($(EXTRA_TOOL),stanse)
-	../tools/jobfile.py $(JOB) $< $@ $(DEFS) $(CFLAGS) $(EXTRA_FLAGS)
-endif
 
 #
@@ -394,7 +390,4 @@
 %.o: %.c $(DEPEND)
 	$(CC) $(DEFS) $(CFLAGS) $(EXTRA_FLAGS) $(FPU_NO_CFLAGS) -c $< -o $@
-ifeq ($(EXTRA_TOOL),stanse)
-	../tools/jobfile.py $(JOB) $< $@ $(DEFS) $(CFLAGS) $(EXTRA_FLAGS) $(FPU_NO_CFLAGS)
-endif
 
 $(REAL_MAP).o: $(REAL_MAP).bin
Index: kernel/Makefile.common
===================================================================
--- kernel/Makefile.common	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/Makefile.common	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -36,5 +36,4 @@
 BIN = kernel.bin
 MAP = kernel.map
-JOB = kernel.job
 MAP_PREV = $(MAP).prev
 DISASM = kernel.disasm
Index: kernel/arch/amd64/include/mm/page.h
===================================================================
--- kernel/arch/amd64/include/mm/page.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/amd64/include/mm/page.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -177,23 +177,5 @@
 #define PFERR_CODE_ID		(1 << 4)
 
-/** Page Table Entry. */
-typedef struct {
-	unsigned present : 1;
-	unsigned writeable : 1;
-	unsigned uaccessible : 1;
-	unsigned page_write_through : 1;
-	unsigned page_cache_disable : 1;
-	unsigned accessed : 1;
-	unsigned dirty : 1;
-	unsigned unused: 1;
-	unsigned global : 1;
-	unsigned soft_valid : 1;		/**< Valid content even if present bit is cleared. */
-	unsigned avl : 2;
-	unsigned addr_12_31 : 30;
-	unsigned addr_32_51 : 21;
-	unsigned no_execute : 1;
-} __attribute__ ((packed)) pte_t;
-
-static inline unsigned int get_pt_flags(pte_t *pt, size_t i)
+static inline int get_pt_flags(pte_t *pt, size_t i)
 {
 	pte_t *p = &pt[i];
Index: kernel/arch/amd64/include/types.h
===================================================================
--- kernel/arch/amd64/include/types.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/amd64/include/types.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -82,4 +82,22 @@
 #define PRIxn "llx"
 
+/** Page Table Entry. */
+typedef struct {
+	unsigned present : 1;
+	unsigned writeable : 1;
+	unsigned uaccessible : 1;
+	unsigned page_write_through : 1;
+	unsigned page_cache_disable : 1;
+	unsigned accessed : 1;
+	unsigned dirty : 1;
+	unsigned unused: 1;
+	unsigned global : 1;
+	unsigned soft_valid : 1;		/**< Valid content even if present bit is cleared. */
+	unsigned avl : 2;
+	unsigned addr_12_31 : 30;
+	unsigned addr_32_51 : 21;
+	unsigned no_execute : 1;
+} __attribute__ ((packed)) pte_t;
+
 #endif
 
Index: kernel/arch/amd64/src/amd64.c
===================================================================
--- kernel/arch/amd64/src/amd64.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/amd64/src/amd64.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -67,5 +67,4 @@
 #include <ddi/irq.h>
 #include <sysinfo/sysinfo.h>
-#include <memstr.h>
 
 /** Disable I/O on non-privileged levels
Index: kernel/arch/amd64/src/interrupt.c
===================================================================
--- kernel/arch/amd64/src/interrupt.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/amd64/src/interrupt.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -98,11 +98,4 @@
 }
 
-static void de_fault(int n, istate_t *istate)
-{
-	fault_if_from_uspace(istate, "Divide error.");
-	decode_istate(n, istate);
-	panic("Divide error.");
-}
-
 /** General Protection Fault. */
 static void gp_fault(int n, istate_t *istate)
@@ -207,5 +200,4 @@
 	}
 	
-	exc_register(0, "de_fault", (iroutine) de_fault);
 	exc_register(7, "nm_fault", (iroutine) nm_fault);
 	exc_register(12, "ss_fault", (iroutine) ss_fault);
Index: kernel/arch/arm32/Makefile.inc
===================================================================
--- kernel/arch/arm32/Makefile.inc	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/arm32/Makefile.inc	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -61,6 +61,5 @@
 	arch/$(KARCH)/src/mm/page.c \
 	arch/$(KARCH)/src/mm/tlb.c \
-	arch/$(KARCH)/src/mm/page_fault.c \
-	arch/$(KARCH)/src/ras.c
+	arch/$(KARCH)/src/mm/page_fault.c
 
 ifeq ($(MACHINE),testarm)
Index: kernel/arch/arm32/include/atomic.h
===================================================================
--- kernel/arch/arm32/include/atomic.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/arm32/include/atomic.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -37,6 +37,4 @@
 #define KERN_arm32_ATOMIC_H_
 
-#include <arch/asm.h>
-
 /** Atomic addition.
  *
@@ -49,14 +47,19 @@
 static inline long atomic_add(atomic_t *val, int i)
 {
-	long ret;
-
-	/*
-	 * This implementation is for UP pre-ARMv6 systems where we do not have
-	 * the LDREX and STREX instructions.
-	 */
-	ipl_t ipl = interrupts_disable();
-	val->count += i;
-	ret = val->count;
-	interrupts_restore(ipl);
+	int ret;
+	volatile long *mem = &(val->count);
+	
+	asm volatile (
+		"1:\n"
+			"ldr r2, [%[mem]]\n"
+			"add r3, r2, %[i]\n"
+			"str r3, %[ret]\n"
+			"swp r3, r3, [%[mem]]\n"
+			"cmp r3, r2\n"
+			"bne 1b\n"
+		: [ret] "=m" (ret)
+		: [mem] "r" (mem), [i] "r" (i)
+		: "r3", "r2"
+	);
 	
 	return ret;
Index: kernel/arch/arm32/include/mm/as.h
===================================================================
--- kernel/arch/arm32/include/mm/as.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/arm32/include/mm/as.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -54,4 +54,5 @@
 #define as_destructor_arch(as)			(as != as)
 #define as_create_arch(as, flags)		(as != as)
+#define as_install_arch(as)
 #define as_deinstall_arch(as)
 #define as_invalidate_translation_cache(as, page, cnt)
Index: kernel/arch/arm32/include/mm/page.h
===================================================================
--- kernel/arch/arm32/include/mm/page.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/arm32/include/mm/page.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -75,5 +75,5 @@
 /* Get PTE address accessors for each level. */
 #define GET_PTL1_ADDRESS_ARCH(ptl0, i) \
-	((pte_t *) ((((pte_t *)(ptl0))[(i)].l0).coarse_table_addr << 10))
+	((pte_t *) ((((pte_level0_t *)(ptl0))[(i)]).coarse_table_addr << 10))
 #define GET_PTL2_ADDRESS_ARCH(ptl1, i) \
 	(ptl1)
@@ -81,19 +81,19 @@
 	(ptl2)
 #define GET_FRAME_ADDRESS_ARCH(ptl3, i) \
-	((uintptr_t) ((((pte_t *)(ptl3))[(i)].l1).frame_base_addr << 12))
+	((uintptr_t) ((((pte_level1_t *)(ptl3))[(i)]).frame_base_addr << 12))
 
 /* Set PTE address accessors for each level. */
 #define SET_PTL0_ADDRESS_ARCH(ptl0) \
-	(set_ptl0_addr((pte_t *) (ptl0)))
+	(set_ptl0_addr((pte_level0_t *) (ptl0)))
 #define SET_PTL1_ADDRESS_ARCH(ptl0, i, a) \
-	(((pte_t *) (ptl0))[(i)].l0.coarse_table_addr = (a) >> 10)
+	(((pte_level0_t *) (ptl0))[(i)].coarse_table_addr = (a) >> 10)
 #define SET_PTL2_ADDRESS_ARCH(ptl1, i, a)
 #define SET_PTL3_ADDRESS_ARCH(ptl2, i, a)
 #define SET_FRAME_ADDRESS_ARCH(ptl3, i, a) \
-	(((pte_t *) (ptl3))[(i)].l1.frame_base_addr = (a) >> 12)
+	(((pte_level1_t *) (ptl3))[(i)].frame_base_addr = (a) >> 12)
 
 /* Get PTE flags accessors for each level. */
 #define GET_PTL1_FLAGS_ARCH(ptl0, i) \
-	get_pt_level0_flags((pte_t *) (ptl0), (size_t) (i))
+	get_pt_level0_flags((pte_level0_t *) (ptl0), (size_t) (i))
 #define GET_PTL2_FLAGS_ARCH(ptl1, i) \
 	PAGE_PRESENT
@@ -101,13 +101,13 @@
 	PAGE_PRESENT
 #define GET_FRAME_FLAGS_ARCH(ptl3, i) \
-	get_pt_level1_flags((pte_t *) (ptl3), (size_t) (i))
+	get_pt_level1_flags((pte_level1_t *) (ptl3), (size_t) (i))
 
 /* Set PTE flags accessors for each level. */
 #define SET_PTL1_FLAGS_ARCH(ptl0, i, x) \
-	set_pt_level0_flags((pte_t *) (ptl0), (size_t) (i), (x))
+	set_pt_level0_flags((pte_level0_t *) (ptl0), (size_t) (i), (x))
 #define SET_PTL2_FLAGS_ARCH(ptl1, i, x)
 #define SET_PTL3_FLAGS_ARCH(ptl2, i, x)
 #define SET_FRAME_FLAGS_ARCH(ptl3, i, x) \
-	set_pt_level1_flags((pte_t *) (ptl3), (size_t) (i), (x))
+	set_pt_level1_flags((pte_level1_t *) (ptl3), (size_t) (i), (x))
 
 /* Macros for querying the last-level PTE entries. */
@@ -115,9 +115,10 @@
 	(*((uint32_t *) (pte)) != 0)
 #define PTE_PRESENT_ARCH(pte) \
-	(((pte_t *) (pte))->l0.descriptor_type != 0)
+	(((pte_level0_t *) (pte))->descriptor_type != 0)
 #define PTE_GET_FRAME_ARCH(pte) \
-	(((pte_t *) (pte))->l1.frame_base_addr << FRAME_WIDTH)
+	(((pte_level1_t *) (pte))->frame_base_addr << FRAME_WIDTH)
 #define PTE_WRITABLE_ARCH(pte) \
-	(((pte_t *) (pte))->l1.access_permission_0 == PTE_AP_USER_RW_KERNEL_RW)
+	(((pte_level1_t *) (pte))->access_permission_0 == \
+	    PTE_AP_USER_RW_KERNEL_RW)
 #define PTE_EXECUTABLE_ARCH(pte) \
 	1
@@ -158,8 +159,4 @@
 } ATTRIBUTE_PACKED pte_level1_t;
 
-typedef union {
-	pte_level0_t l0;
-	pte_level1_t l1;
-} pte_t;
 
 /* Level 1 page tables access permissions */
@@ -194,5 +191,5 @@
  * @param pt    Pointer to the page table to set.
  */   
-static inline void set_ptl0_addr(pte_t *pt)
+static inline void set_ptl0_addr(pte_level0_t *pt)
 {
 	asm volatile (
@@ -208,7 +205,7 @@
  *  @param i      Index of the entry to return.
  */
-static inline int get_pt_level0_flags(pte_t *pt, size_t i)
-{
-	pte_level0_t *p = &pt[i].l0;
+static inline int get_pt_level0_flags(pte_level0_t *pt, size_t i)
+{
+	pte_level0_t *p = &pt[i];
 	int np = (p->descriptor_type == PTE_DESCRIPTOR_NOT_PRESENT);
 
@@ -223,7 +220,7 @@
  *  @param i      Index of the entry to return.
  */
-static inline int get_pt_level1_flags(pte_t *pt, size_t i)
-{
-	pte_level1_t *p = &pt[i].l1;
+static inline int get_pt_level1_flags(pte_level1_t *pt, size_t i)
+{
+	pte_level1_t *p = &pt[i];
 
 	int dt = p->descriptor_type;
@@ -248,7 +245,7 @@
  *  @param flags  new flags
  */
-static inline void set_pt_level0_flags(pte_t *pt, size_t i, int flags)
-{
-	pte_level0_t *p = &pt[i].l0;
+static inline void set_pt_level0_flags(pte_level0_t *pt, size_t i, int flags)
+{
+	pte_level0_t *p = &pt[i];
 
 	if (flags & PAGE_NOT_PRESENT) {
@@ -276,7 +273,7 @@
  *  @param flags  New flags.
  */  
-static inline void set_pt_level1_flags(pte_t *pt, size_t i, int flags)
-{
-	pte_level1_t *p = &pt[i].l1;
+static inline void set_pt_level1_flags(pte_level1_t *pt, size_t i, int flags)
+{
+	pte_level1_t *p = &pt[i];
 	
 	if (flags & PAGE_NOT_PRESENT) {
Index: kernel/arch/arm32/include/types.h
===================================================================
--- kernel/arch/arm32/include/types.h	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/arm32/include/types.h	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -87,4 +87,13 @@
 #define PRIxn "x"	/**< Format for hexadecimal (u)native_t. */
 
+/** Page table entry.
+ *
+ *  We have different structs for level 0 and level 1 page table entries.
+ *  See page.h for definition of pte_level*_t.
+ */
+typedef struct {
+	unsigned dummy : 32;
+} pte_t;
+
 #endif
 
Index: kernel/arch/arm32/src/arm32.c
===================================================================
--- kernel/arch/arm32/src/arm32.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/arm32/src/arm32.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -48,5 +48,4 @@
 #include <macros.h>
 #include <string.h>
-#include <arch/ras.h>
 
 #ifdef MACHINE_testarm
@@ -89,7 +88,4 @@
 	exception_init();
 	interrupt_init();
-
-	/* Initialize Restartable Atomic Sequences support. */
-	ras_init();
 	
 	machine_output_init();
@@ -140,4 +136,5 @@
 	uint8_t *stck;
 	
+	tlb_invalidate_all();
 	stck = &THREAD->kstack[THREAD_STACK_SIZE - SP_DELTA];
 	supervisor_sp = (uintptr_t) stck;
Index: kernel/arch/arm32/src/exc_handler.S
===================================================================
--- kernel/arch/arm32/src/exc_handler.S	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/arm32/src/exc_handler.S	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -148,5 +148,5 @@
 	mov r0, #0
 	mov r1, r13
-	bl ras_check 
+	bl exc_dispatch
 	LOAD_REGS_FROM_STACK
 
@@ -156,5 +156,5 @@
 	mov r0, #5
 	mov r1, r13
-	bl ras_check 
+	bl exc_dispatch
 	LOAD_REGS_FROM_STACK
 
@@ -164,5 +164,5 @@
 	mov r0, #6
 	mov r1, r13
-	bl ras_check 
+	bl exc_dispatch
 	LOAD_REGS_FROM_STACK
 
@@ -171,5 +171,5 @@
 	mov r0, #1
 	mov r1, r13
-	bl ras_check 
+	bl exc_dispatch
 	LOAD_REGS_FROM_STACK
 
@@ -179,5 +179,5 @@
 	mov r0, #3
 	mov r1, r13
-	bl ras_check 
+	bl exc_dispatch
 	LOAD_REGS_FROM_STACK
 
@@ -187,5 +187,5 @@
 	mov r0, #4
 	mov r1, r13
-	bl ras_check 
+	bl exc_dispatch
 	LOAD_REGS_FROM_STACK
 
@@ -195,5 +195,5 @@
 	mov r0, #2
 	mov r1, r13
-	bl ras_check
+	bl exc_dispatch
 	LOAD_REGS_FROM_STACK
 
Index: kernel/arch/arm32/src/mm/as.c
===================================================================
--- kernel/arch/arm32/src/mm/as.c	(revision eacb957f6c30d6c807f9a5ca0a3e535e59262c52)
+++ kernel/arch/arm32/src/mm/as.c	(revision 245e8399f3d58ad45fc1730f6b948b33ae3ab8df)
@@ -36,8 +36,6 @@
 #include <arch/mm/as.h>
 #include <genarch/mm/as_pt.h>
-#include <genarch/mm/page_pt.h>
 #include <genarch/mm/asid_fifo.h>
 #include <mm/as.h>
-#include <mm/tlb.h>
 #include <arch.h>
 
@@ -51,9 +49,4 @@
 }
 
-void as_install_arch(as_t *as)
-{
-	tlb_invalidate_all();
-}
-
 /** @}
  */
